%%%%%%% Test of Lipschitz inequality for CD-BM3D %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 clear all
 close all
%%%%%%%%%%%% Parameters for CD-BM3D %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% close all
param.nm1 = 8;  %% N1 x N1 is the block size used for the hard-thresholding (HT) filtering
param.Nstep =3; %% sliding step to process every next reference block
param.nm2 =floor(param.nm1*param.nm1/2); %% maximum number of similar blocks (maximum size of the 3rd dimension of a 3D array)
param.Ns = 39;  %% length of the side of the search neighborhood for full-search block-matching (BM), must be odd
sigma=.3*255;   %% noise level
%% param.lambda3D=lambda3D;      %% parameter for the thresholding
param.lambda_conf_int=2;         %% parameter for the two sides symmetric confidence interval for grouping
param.lambda_conf_int_factor=10; %% parameter for the upper bound in the two sides non-symmetric confidence interval for grouping
param.doBlockMatching=1;         %% false (0) means that the new grouping is produced, true (1) means that the previous grouping is used 
param.bm2D3Dhosvd_index3D=1;     %% 1 stays for high-order 3D SVD, otherwise 2D SVD
param.sigma = sigma;             %% STD of the additive Gaussian noise
param.lambda2D       =  0.0;     %% threshold parameter for the coarse initial denoising used in the d-distance measure

% Two sided confidence interval for grouping
%% lower bound
param.lambda_conf(1)=max(0,(param.nm1^2-param.lambda_conf_int*sqrt(2*param.nm1^2))*param.sigma^2*2/255^2);
% upper bound
param.lambda_conf(2)= (param.nm1^2+param.lambda_conf_int*sqrt(2*param.nm1^2))*param.sigma^2*2/255^2*param.lambda_conf_int_factor;
param.thresholding_type='s';


AA=[10];                          %% Width of smoothing uniforn kernel
s=0;
 for test_phase=6 %%[3 4 8 9 10];  %% First test image 
    s=s+1;
    
  lambda3D_set=[.5 1 2 3.0 4 5];  %% Set of threshold parameters
  ss=0;
   for lambda3D=lambda3D_set
    ss=ss+1;

param.lambda3D=lambda3D;
%%% Object models are from the file Observation_Models.m
 test_phase=4;
 Observation_Models 
     
 %% First input signal u1   
 Y1=exp(1i*varphi);
 u1=Y1 + sigma/255*conv2(randn(size(Y1))+1i*randn(size(Y1)),AA,'same'); %% Noisy signal
% %      %% real valued test
% %      Y1=varphi;
% %      u1=Y1 + sigma/255*conv2(randn(size(Y1))+0*1i*randn(size(Y1)),AA,'same'); %% Noisy signal
% %      
     
 %% u1_ = wthresh(u1,'h',T);

[u1_,nnzTransfElements]  = CDBM3Dp(u1, param);
%% figure, imshow(angle(u1_),[])


 %% Second input signal u2
 test_phase=3;
Observation_Models 
clear test_phase
     
     Y2=exp(1i*varphi);
     u2=Y2 + sigma/255*conv2(randn(size(Y1))+1i*randn(size(Y1)),AA,'same'); %% Noisy signal
     
     %% real valued 
    Y2=varphi;
    u2=Y2 + sigma/255*conv2(randn(size(Y1))+0*1i*randn(size(Y1)),AA,'same'); %% Noisy signal
    
[u2_,nnzTransfElements]  = CDBM3Dp(u2, param);


k_delta(s,ss)=norm(u1_(:)-u2_(:),2)/(norm(u1(:)-u2(:),2)+eps)  %% Lipshitz parameter
    end
end


figure, plot(k_delta'), grid on, xlabel('Threshold'), ylabel('k_{\eta}'), title('LIPSCITZ PARAMETER VERSUS THRESHOLD'),...
   %%  legend('\sigma =.01','\delta =.02','\delta =.03','\delta =.04','\delta =.05')
% k_delta
%%figure, plot(AA,k_delta','-o'),grid,
%  figure, plot(k_delta'), grid on, xlabel('Threshold'), ylabel('k_{\eta}'), title('LIPSCITZ PARAMETER VERSUS THRESHOLD'),...
%      legend('\eta =.01','\delta =.02','\delta =.03','\delta =.04','\delta =.05')